#!/usr/bin/python

import xmlrpclib
from client import client
from pprint import pprint

# Mark all all incoming packing to be complete

c = client()
wizard_sock = xmlrpclib.ServerProxy(c.rpc_url+'/wizard')

sp_ids_to_receive = c.search(
      'stock.picking',
      [ 
        ('state', '=',    'assigned'),
        ('type',  '=',    'in'),
      ]
      )


for sp_id_to_receive in sp_ids_to_receive:

    print "Received sp_id: ", sp_id_to_receive

    #####################################[ wizard / create ]############
    # ('2011-09-02-sandbox', UID, 'PASSWORD', u'stock.partial_picking')
    wizard_key = wizard_sock.create(
        c.dbname,
        c.user_id,
        c.pwd,
        'stock.partial_picking'
    )

    #####################################[ wizard / execute ]############
    # ('2011-09-02-sandbox', UID, 'PASSWORD', 
    # 1, 
    # {'model': u'stock.picking', 'report_type': 'pdf', 'id': 1276, 'form': {}, 'ids': [1276]}, 
    # 'init', 
    # {'lang': u'en_CA', 'tz': False, 'active_model': u'stock.picking', 
    #  'contact_display': 'partner', 'active_ids': [1276], 'active_id': 1276})
    result = wizard_sock.execute(
        c.dbname,
        c.user_id,
        c.pwd,
        wizard_key,
        {'model': u'stock.picking', 'report_type': 'pdf', 'id': sp_id_to_receive, 'form': {}, 'ids': [sp_id_to_receive]},
        'init',
        {'lang': u'en_CA', 'tz': False, 'active_model': u'stock.picking', 
        'contact_display': 'partner', 
        'active_ids': [sp_id_to_receive], 'active_id': sp_id_to_receive}
        )

    # Result will now hold something like this:
    # {'arch': '<form string="Make packing">\n<field name="move5097"/>\n<group col="6"><field name="uom5097" nolabel="1"/>                    <field name="price5097"/>\n<field name="currency5097" nolabel="1"/></group>\n<newline/>\n</form>',
    #  'datas': {'moves': [5097]},
    #  'fields': {'currency5097': {'relation': 'res.currency',
    #                              'required': True,
    #                              'string': 'Currency',
    #                              'type': 'many2one',
    #                              'value': 2},
    #             'move5097': {'required': True,
    #                          'string': 'PO:[LC2U06A] Stepper Motor Connector - Vexta',
    #                          'type': 'float',
    #                          'value': 20.0},
    #             'price5097': {'required': True,
    #                           'string': 'Unit Price',
    #                           'type': 'float',
    #                           'value': 4.0},
    #             'uom5097': {'relation': 'product.uom',
    #                         'required': True,
    #                         'string': 'UOM',
    #                         'type': 'many2one',
    #                         'value': 1}},
    #  'state': [['end', 'Cancel'], ['split', 'Make Picking']],
    #  'type': 'form'}

    form = result['datas']
    for field,data in result['fields'].iteritems():
        form[field] = data['value']

    #####################################[ wizard / execute ]############
    # ('2011-09-02-sandbox', UID, 'PASSWORD', 
    # 1, 
    # {
    #    'model': u'stock.picking', 
    #    'report_type': 'pdf', 
    #    'id': 1276, 
    #    'form': {
    #               'moves': [14349, 14350], 
    #               'currency14349': 2, 'price14349': 39.009999999999998, 
    #               'move14349': 35.0, 
    #               'uom14349': 1, 
    #               'uom14350': 1, 
    #               'currency14350': 2, 
    #               'move14350': 12.0, 
    #               'price14350': 46.909999999999997
    #            }, 
    #    'ids': [1276]
    #  }, 
    # 'split', {
    #           'lang': u'en_CA', 
    #           'tz': False, 
    #           'active_model': u'stock.picking', 
    #           'contact_display': 'partner', 
    #           'active_ids': [1276], 
    #           'active_id': 1276})

    result = wizard_sock.execute(
        c.dbname,
        c.user_id,
        c.pwd,
        wizard_key,
        {
          'model': u'stock.picking', 
          'report_type': 'pdf', 
          'id': sp_id_to_receive, 
          'form': form, 
          'ids': [sp_id_to_receive]
        },
        'split',
        {'lang': u'en_CA', 'tz': False, 'active_model': u'stock.picking', 
        'contact_display': 'partner', 
        'active_ids': [sp_id_to_receive], 'active_id': sp_id_to_receive}
        )


    pprint(result)

