from client import client

""" Combine all stock locations into the main stock location.
"""

LOC_STOCK = 11
DEPRECATION_PREFIX = '[Do not use] '
NAME_CHANGES = """
Partner Locations|Partner Locations
Partner Locations/Customers|Customers
Partner Locations/Suppliers|Suppliers
Partner Locations/Suppliers/Altech Anodizing|Altech Anodizing
Partner Locations/Suppliers/Alzar|Alzar
Partner Locations/Suppliers/Barton Industries|Barton Industries
Partner Locations/Suppliers/Dorigo|Dorigo
Partner Locations/Suppliers/Parylene Engineering|Parylene Engineering
Physical Locations|Physical Locations
Physical Locations/Zaber|Zaber
Physical Locations/Zaber/Internal Use - Non-R&D|General Internal
Physical Locations/Zaber/Internal Use - R&D|R&D Internal
Physical Locations/Zaber/Obsolete|Obsolete
Physical Locations/Zaber/Output|Output
Physical Locations/Zaber/Salvage|Salvage
Physical Locations/Zaber/Stock|Stock
Physical Locations/Zaber/Stock/Components|Components
Physical Locations/Zaber/Stock/Components/Components - 3rd Floor in an assembly|DELETE
Physical Locations/Zaber/Stock/Components/Components - Aaron's Office|Aaron
Physical Locations/Zaber/Stock/Components/Components - Dave's Office|Dave
Physical Locations/Zaber/Stock/Components/Components - do not use|CHECK WITH BRIAN
Physical Locations/Zaber/Stock/Components/Components - Jesse's desk|Jesse
Physical Locations/Zaber/Stock/Components/Components - NOT IN STOCK|Not in stock yet
Physical Locations/Zaber/Stock/Components/Components - Not in stock yet|Not in stock yet
Physical Locations/Zaber/Stock/Components/Components - NW Back Room|NW Back Room
Physical Locations/Zaber/Stock/Components/Components - On lead screw|DELETE
Physical Locations/Zaber/Stock/Components/Components - Rob's Office|Rob
Physical Locations/Zaber/Stock/Components/Hallway|Hallway
Physical Locations/Zaber/Stock/Components/Hallway/Components - Hallway - Cabinet #3|Hallway
Physical Locations/Zaber/Stock/Components/Hallway/Components - Hallway - Cabinet #7|Hallway
Physical Locations/Zaber/Stock/Components/Hallway/Components - Hallway - Cabinet #7: On top in UST parts Box|Hallway
Physical Locations/Zaber/Stock/Components/Machine Shop|Machine Shop
Physical Locations/Zaber/Stock/Components/Machine Shop/Components - Machine Shop - 2nd Shelf|Machine Shop
Physical Locations/Zaber/Stock/Components/Machine Shop/Components - Machine Shop - 3rd Shelf|Machine Shop
Physical Locations/Zaber/Stock/Components/Machine Shop/Components - Machine Shop - 4th Shelf|Machine Shop
Physical Locations/Zaber/Stock/Components/Machine Shop/Components - Machine Shop - Bottom Shelf|Machine Shop
Physical Locations/Zaber/Stock/Components/Machine Shop/Components - Machine Shop - NW Corner|Machine Shop
Physical Locations/Zaber/Stock/Components/Packing|Packing Area
Physical Locations/Zaber/Stock/Components/Packing/Components - Packing - Cabinet #13: 3rd Shelf|Packing Area
Physical Locations/Zaber/Stock/Components/Packing/Components - Packing - Cabinet #13: Bottom Shelf|Packing Area
Physical Locations/Zaber/Stock/Components/Packing/Components - Packing - Cabinet #13: Top Shelf|Packing Area
Physical Locations/Zaber/Stock/Components/Production Room 1|Production Room 1
Physical Locations/Zaber/Stock/Components/Production Room 1/Components - Production Room 1 - Box: LA Final Assy|T-LA Final Assembly Case
Physical Locations/Zaber/Stock/Components/Production Room 1/Components - Production Room 1 - Box: Lead Screw Assy|T-LA Lead Screw Assembly Case
Physical Locations/Zaber/Stock/Components/Production Room 1/Components - Production Room 1 - Box: Lead Screws|T-LA Lead Screw Case
Physical Locations/Zaber/Stock/Components/Production Room 1/Components - Production Room 1 - Box: MM2 Parts|T-MM2 Case
Physical Locations/Zaber/Stock/Components/Production Room 1/Components - Production Room 1 - Cabinet #17: 3rd Drawer|Production Room 1
Physical Locations/Zaber/Stock/Components/Production Room 1/Components - Production Room 1 - Cabinet #17: Bottom Drawer|Production Room 1
Physical Locations/Zaber/Stock/Components/Production Room 1/Components - Production Room 1 - Case: T-CD/NA/NM/LM Assy|NA/NM/LM Case
Physical Locations/Zaber/Stock/Components/Production Room 1/Components - Production Room 1 - Case: T-NA Assy|T-NA Case
Physical Locations/Zaber/Stock/Components/Production Room 1/Components - Production Room 1 - Case: T-RS Assy|T-RS Case
Physical Locations/Zaber/Stock/Components/Production Room 1/Components - Production Room 1 - Clean Room Box|Clean Room Box
Physical Locations/Zaber/Stock/Components/Production Room 1/Components - Production Room 1 - NE Corner|Production Room 1
Physical Locations/Zaber/Stock/Components/Production Room 1/Components - Production Room 1 - Shelving Unit #1|Production Room 1
Physical Locations/Zaber/Stock/Components/Production Room 1/Components - Production Room 1 - Shelving Unit #9: Bottom Drawer|Production Room 1
Physical Locations/Zaber/Stock/Components/Production Room 1/Components - Production Room 1 - Torbin's Desk|Production Room 1
Physical Locations/Zaber/Stock/Components/Production Room 2|Production Room 2
Physical Locations/Zaber/Stock/Components/Production Room 2/Components - Production Room 2 - Case: TSB/T-NM/T-LLS/T-LS Assy|TSB/T-NM/T-LLS/T-LS Case
Physical Locations/Zaber/Stock/Components/Production Room 2/Components - Production Room 2 - Interior Window|DELETE
Physical Locations/Zaber/Stock/Components/Stores|Stores
Physical Locations/Zaber/Stock/Components/Stores/Components - Stores - ????|DELETE
Physical Locations/Zaber/Stock/Components/Stores/Components - Stores - NW Corner|Stores Section I
Physical Locations/Zaber/Stock/Components/Stores/Section A|Stores Section A
Physical Locations/Zaber/Stock/Components/Stores/Section A/Components - Stores - Section A - 2nd Shelf - Connectors Box|Stores Section A
Physical Locations/Zaber/Stock/Components/Stores/Section A/Components - Stores - Section A - Cabinet #1|Stores Section A
Physical Locations/Zaber/Stock/Components/Stores/Section A/Components - Stores - Section A - Cabinet #1: Bottom Shelf|Stores Section A
Physical Locations/Zaber/Stock/Components/Stores/Section A/Components - Stores - Section A - Cabinet #1: Silver Cases|Stores Section A
Physical Locations/Zaber/Stock/Components/Stores/Section A/Components - Stores - Section A - Cabinet #2|Stores Section A
Physical Locations/Zaber/Stock/Components/Stores/Section A/Components - Stores - Section A - Cabinet #2: 2nd Shelf|Stores Section A
Physical Locations/Zaber/Stock/Components/Stores/Section A/Components - Stores - Section A - Cabinet #2: 5th Shelf|Stores Section A
Physical Locations/Zaber/Stock/Components/Stores/Section A/Components - Stores - Section A - Cabinet #2: Bottom Shelf|Stores Section A
Physical Locations/Zaber/Stock/Components/Stores/Section A/Components - Stores - Section A - Case: PCB Assy|Stores Section A
Physical Locations/Zaber/Stock/Components/Stores/Section A/Components - Stores - Section A - Case: T-MCA Assy|Stores Section A
Physical Locations/Zaber/Stock/Components/Stores/Section B|Stores Section B
Physical Locations/Zaber/Stock/Components/Stores/Section B/Components - Stores - Section B - 2nd Shelf|Stores Section B2
Physical Locations/Zaber/Stock/Components/Stores/Section B/Components - Stores - Section B - 3rd Shelf|Stores Section B3
Physical Locations/Zaber/Stock/Components/Stores/Section B/Components - Stores - Section B - 4th Shelf|Stores Section B4
Physical Locations/Zaber/Stock/Components/Stores/Section B/Components - Stores - Section B - Bottom Shelf|Stores Section B1
Physical Locations/Zaber/Stock/Components/Stores/Section B/Components - Stores - Section B - Top Shelf|Stores Section B5
Physical Locations/Zaber/Stock/Components/Stores/Section C|Stores Section C
Physical Locations/Zaber/Stock/Components/Stores/Section C/Components - Stores - Section C - 2nd Shelf|Stores Section C2
Physical Locations/Zaber/Stock/Components/Stores/Section C/Components - Stores - Section C - 3rd Shelf|Stores Section C3
Physical Locations/Zaber/Stock/Components/Stores/Section C/Components - Stores - Section C - 3rd Shelf - TO DELETE|DELETE
Physical Locations/Zaber/Stock/Components/Stores/Section C/Components - Stores - Section C - 4th Shelf|Stores Section C4
Physical Locations/Zaber/Stock/Components/Stores/Section C/Components - Stores - Section C - Bottom Shelf|Stores Section C1
Physical Locations/Zaber/Stock/Components/Stores/Section C/Components - Stores - Section C - Top Shelf|Stores Section C5
Physical Locations/Zaber/Stock/Components/Stores/Section D|Stores Section D
Physical Locations/Zaber/Stock/Components/Stores/Section D/Components - Stores - Section D - 2nd Shelf|Stores Section D2
Physical Locations/Zaber/Stock/Components/Stores/Section D/Components - Stores - Section D - 3rd Shelf|Stores Section D3
Physical Locations/Zaber/Stock/Components/Stores/Section D/Components - Stores - Section D - 4th Shelf|Stores Section D4
Physical Locations/Zaber/Stock/Components/Stores/Section D/Components - Stores - Section D - Bottom Shelf|Stores Section D1
Physical Locations/Zaber/Stock/Components/Stores/Section D/Components - Stores - Section D - Top Shelf|Stores Section D5
Physical Locations/Zaber/Stock/Components/Stores/Section E|Stores Section E
Physical Locations/Zaber/Stock/Components/Stores/Section E/Components - Stores - Section E - 2nd Shelf|Stores Section E4
Physical Locations/Zaber/Stock/Components/Stores/Section E/Components - Stores - Section E - 3rd Shelf|Stores Section E3
Physical Locations/Zaber/Stock/Components/Stores/Section E/Components - Stores - Section E - 4th Shelf|Stores Section E2
Physical Locations/Zaber/Stock/Components/Stores/Section E/Components - Stores - Section E - 4th Shelf Threaded in CID 528|DELETE
Physical Locations/Zaber/Stock/Components/Stores/Section E/Components - Stores - Section E - 4th Shelf Threaded in CID 540|DELETE
Physical Locations/Zaber/Stock/Components/Stores/Section E/Components - Stores - Section E - Bottom Shelf|Stores Section E1
Physical Locations/Zaber/Stock/Components/Stores/Section E/Components - Stores - Section E - Top Shelf|Stores Section E5
Physical Locations/Zaber/Stock/Components/Stores/Section F|Stores Section F
Physical Locations/Zaber/Stock/Components/Stores/Section F/Components - Stores - Section F - 2nd Shelf|Stores Section F2
Physical Locations/Zaber/Stock/Components/Stores/Section F/Components - Stores - Section F - 2nd Shelf (in 406.01 box)|Stores Section F2
Physical Locations/Zaber/Stock/Components/Stores/Section F/Components - Stores - Section F - 3rd Shelf|Stores Section F3
Physical Locations/Zaber/Stock/Components/Stores/Section F/Components - Stores - Section F - 4th Shelf|Stores Section F4
Physical Locations/Zaber/Stock/Components/Stores/Section F/Components - Stores - Section F - 5th Shelf|Stores Section F5
Physical Locations/Zaber/Stock/Components/Stores/Section F/Components - Stores - Section F - Bottom Shelf|Stores Section F1
Physical Locations/Zaber/Stock/Components/Stores/Section F/Components - Stores - Section F - C Component Shelving|Stores Section J
Physical Locations/Zaber/Stock/Components/Stores/Section F/Components - Stores - Section F - On Floor against window/wall|Stores Section I
Physical Locations/Zaber/Stock/Components/Stores/Section F/Components - Stores - Section F - On Top of Shelving Unit|Stores Section F7
Physical Locations/Zaber/Stock/Components/Stores/Section F/Components - Stores - Section F - Top Shelf|Stores Section F6
Physical Locations/Zaber/Stock/Components/Stores/Section G|Stores Section G
Physical Locations/Zaber/Stock/Components/Stores/Section G/Components - Stores - Section G - 2nd Shelf|Stores Section G2
Physical Locations/Zaber/Stock/Components/Stores/Section G/Components - Stores - Section G - Motors|Section G Motors
Physical Locations/Zaber/Stock/Components/Stores/Section G/Components - Stores - Section G - Top Shelf|Stores Section G5
Physical Locations/Zaber/Stock/Components/Stores/Section H|Stores Section H
Physical Locations/Zaber/Stock/Components/Stores/Section H/Components - Stores - Section H - 2nd Shelf|Stores Section H2
Physical Locations/Zaber/Stock/Components/Stores/Section H/Components - Stores - Section H - 3rd Shelf|Stores Section H3
Physical Locations/Zaber/Stock/Components/Stores/Section H/Components - Stores - Section H - Bin 1|Stores Section I
Physical Locations/Zaber/Stock/Components/Stores/Section H/Components - Stores - Section H - Bottom Shelf|Stores Section H1
Physical Locations/Zaber/Stock/Components/Stores/Section H/Components - Stores - Section H - Top Shelf|Stores Section H4
Physical Locations/Zaber/Stock/Finished|Finished Goods
Physical Locations/Zaber/Stock/Finished/Finished - Production Room 1|Finished Goods
Physical Locations/Zaber/Stock/Preproduction|Preproduction
Physical Locations/Zaber/Stock/Released Blanket Orders|Released Blanket Orders
Physical Locations/Zaber/Stock/WIP|WIP
Physical Locations/Zaber/Stock/WIP/WIP - Production Room 1|WIP
Physical Locations/Zaber/Stock/WIP/WIP - Production Room 2|WIP
Virtual Locations|Virtual Locations
Virtual Locations/Consumed for non-R&D|General Consumption - Virtual
Virtual Locations/Consumed for R&D|R&D Consumption - Virtual
Virtual Locations/Garbage - Virtual|Garbage - Virtual
Virtual Locations/Inventory loss - Virtual|Inventory loss - Virtual
Virtual Locations/Procurements|Procurements - Virtual
Virtual Locations/Production - Virtual|Production - Virtual
""".strip()
c = client()

max_length = 64 - len(DEPRECATION_PREFIX)
name_map = {}
for name_change in NAME_CHANGES.splitlines():
    old_path_name, pipe, new = name_change.partition('|')
    old_path = old_path_name.split('/')
    old = old_path[-1]
    for i in range(len(old_path)):
        if '-' in old_path[i]:
            old = '/'.join(old_path[i:])
            break
    old = old[0:max_length]
    name_map[old] = new
    
rows = c.search_fetch(
    'stock.location',
    [('location_id', 'child_of', [LOC_STOCK])],
    ['name'])

location_map = {} # location_id -> new name
for row in rows:
    old = row['name']
    
    location_id = row['id']
    if old.startswith(DEPRECATION_PREFIX):
        old = old[len(DEPRECATION_PREFIX):]
    elif location_id != LOC_STOCK:
        c.update(
            'stock.location', 
            [location_id], 
            {'name': DEPRECATION_PREFIX + old})
    old = old[0:max_length]
    new = name_map[old]
    location_map[location_id] = new

all_paths = c.search_fetch(
    'stock.location.path',
    [],
    ['product_id', 'location_from_id', 'location_dest_id'])
all_paths = all_paths or []

bad_path_products = [
    path['product_id'] 
    for path in all_paths 
    if path['location_from_id'][0] != LOC_STOCK]

if bad_path_products:
    for product in bad_path_products:
        print product
    raise RuntimeError, "Path didn't start from Stock location."

class ProductInfo(object):
    pass

product_map = {} # product_id -> ProductInfo
template_map = {} # template_id -> ProductInfo
path_product_ids = [path['product_id'][0] for path in all_paths]
path_products = c.fetch(
    'product.product',
    path_product_ids,
    ['product_tmpl_id', 'default_code'])
path_template_ids = []
for product in path_products:
    product_info = ProductInfo()
    product_info.product_id = product['id']
    product_info.product_tmpl_id = product['product_tmpl_id'][0]
    product_info.default_code = product['default_code']
    product_map[product_info.product_id] = product_info
    template_map[product_info.product_tmpl_id] = product_info
    path_template_ids.append(product_info.product_tmpl_id)

path_templates = c.fetch(
        'product.template',
        path_template_ids,
        ['loc_rack', 'loc_row'])
for template in path_templates:
    product_info = template_map[template['id']]
    product_info.loc_rack = template['loc_rack']
    product_info.loc_row = template['loc_row']
    
for path in all_paths:
    product_info = product_map[path['product_id'][0]]
    location_id = path['location_dest_id'][0]
    location_name = location_map[location_id]
    if product_info.loc_rack != location_name:
        if product_info.loc_row:
            msg = "loc_row already set for %s." % product_info.default_code
            raise RuntimeError, msg
        c.update(
            'product.template',
            [product_info.product_tmpl_id],
            {'loc_rack': location_name, 'loc_row': product_info.loc_rack})
c.unlink(
    'stock.location.path',
    [path['id'] for path in all_paths])

child_location_ids = location_map.keys()
child_location_ids.remove(LOC_STOCK)

def update_to_stock(model, field):
    count = 0
    limit = 1000
    is_done = False
    while not is_done:
        ids = c.search(
            model,
            [(field, 'in', child_location_ids)],
            span_limit=limit)
        c.update(
            model,
            ids,
            {field: LOC_STOCK})
        count += len(ids)
        print "%d in %s.%s." % (count, model, field)
        is_done = len(ids) < limit
    
update_to_stock('stock.location', 'chained_location_id')
update_to_stock('stock.move', 'location_id')
update_to_stock('stock.move', 'location_dest_id')
update_to_stock('mrp.procurement', 'location_id')
update_to_stock('mrp.production', 'location_dest_id')
update_to_stock('mrp.production', 'location_src_id')
update_to_stock('mrp.repair', 'location_id')
update_to_stock('mrp.repair', 'location_dest_id')
update_to_stock('mrp.repair.line', 'location_id')
update_to_stock('mrp.repair.line', 'location_dest_id')
update_to_stock('mrp.routing', 'location_id')
update_to_stock('purchase.order', 'location_id')
update_to_stock('stock.inventory.line', 'location_id')
update_to_stock('stock.picking', 'location_id')
update_to_stock('stock.picking', 'location_dest_id')
update_to_stock('stock.warehouse.orderpoint', 'location_id')


print 'Success.'
