#!/usr/bin/python

import csv
import datetime
import time

fin = open("/mnt/share/server-log/server-log-2012-02-03.txt","r")
#fin = open("/mnt/share/server-log/server-log2.txt","r")
r = csv.reader(fin)

#total,   request,net,    ip,           bytes, time,                 object, obj2,  params,        params2,cpu,ticks_idle,ticks_total, user_id?
#0.057641,0.05757,7.1e-05,192.168.1.206,13,2011-12-05 10:43:38.635739,object,execute,account.invoice,write,7.0,6365954736,7284063871

#total,   request,net,     ip,           bytes, time,                   object, obj2,  params,        params2,                                                                           cpu,ticks_idle,ticks_total, user_id?
#0.487533,0.487413,0.00012,192.168.1.102,243,2011-12-09 13:36:07.601130,wizard,execute,164,"{'model': u'mrp.production', 'report_type': 'pdf', 'id': 10335, 'form': {}, 'ids': [10335]}",48.0,6498519404,7426993571

#total,   request,net,     ip,          bytes, time,                 object, obj2,  params,  params2,cpu,ticks_idle,ticks_total, user_id
#0.014537,0.014466,7.1e-05,192.168.1.16,18,2011-12-20 06:55:44.976117,object,execute,res.lang,search,2.0,6845036070,7798790680,28

headers = [
    'total_time',
    'total_time_for_request_handling',
    'total_time_for_network_handling',
    'remote_ip',
    'byte_size',
    'request_time',
    'request_object',
    'request_object2',
    'request_params',
    'request_params2',
    'cpu_use',
    'cpu_ticks_idle',
    'cpu_ticks_total',
    'user_id',
]

class Conversation(object):
    def __init__(self, user_id):
        self.user_id = user_id
        self.time = None
        self.duration = 0.0
        self.objects = []
        self.objects2 = []
        self.params = []
        self.params2 = []
    
    def add_message(self, time, duration, obj, object2, params, params2):
        self.time = time + datetime.timedelta(seconds=duration)
        self.duration += duration
        self.objects.append(obj)
        self.objects2.append(object2)
        self.params.append(params)
        self.params2.append(params2)
    
    def is_active(self, time):
        """ Check if this conversation is still active at the requested time.
        
        Returns true if time is less than one second after the conversation's
        last message.
        """
        delay = time - self.time
        return delay.days == 0 and delay.seconds == 0 

# {user_id: current conversation}
user_conversations = {}
current_hour = None
current_hour_conversations = []
hour_interval = datetime.timedelta(hours=1)
all_durations = []

print "hour                \tcnCount\tavgCnTm\t25time\t50time\t75time\t90time\tex.1ct\tex1ct\tex10ct"
def summarize_current_hour():
    durations = [c.duration for c in current_hour_conversations]
    all_durations.extend(durations)
    count = len(durations)
    if count <= 120:
        return
    average_duration = sum(durations) / count
    durations.sort()
    index25 = count // 4
    index50 = count // 2
    index75 = (3 * count) // 4
    index90 = (9 * count) // 10
    exceed100ms = 0
    exceed1s = 0
    exceed10s = 0
    for i in range(count-1, -1, -1):
        duration = durations[i]
        if duration > 10:
            exceed10s += 1
        elif duration > 1:
            exceed1s += 1
        elif duration > 0.1:
            exceed100ms += 1
        else:
            break
    print "%s\t%d\t%0.3f\t%0.3f\t%0.3f\t%0.3f\t%0.3f\t%d\t%d\t%d" % (
        current_hour, 
        count,
        average_duration,
        durations[index25],
        durations[index50],
        durations[index75],
        durations[index90],
        exceed100ms,
        exceed1s,
        exceed10s)
        

i = 0
for row in r:
    rec = dict(zip(headers,row))
    if 'user_id' not in rec:
        continue
    user_id = rec['user_id']
    
    duration = float(rec['total_time'])

    date = rec['request_time']
    date_obj = datetime.datetime.strptime(date,'%Y-%m-%d %H:%M:%S.%f')
    day = date_obj.strftime('%Y-%m-%d')
    time = date_obj.strftime('%Y-%m-%d %H:00')
    if current_hour == None:
        current_hour = datetime.datetime(
            date_obj.year, 
            date_obj.month, 
            date_obj.day, 
            date_obj.hour, 
            0)
        next_hour = current_hour + hour_interval
    
    conversation = user_conversations.get(user_id)
    if not conversation or not conversation.is_active(date_obj):
        if conversation:
            for user_id, conversation in user_conversations.iteritems():
                if conversation and not conversation.is_active(date_obj):
                    current_hour_conversations.append(conversation)
                    user_conversations[user_id] = None
            while date_obj >= next_hour:
                summarize_current_hour()
                current_hour_conversations = []
                current_hour = next_hour
                next_hour += hour_interval
            i += 1
        conversation = Conversation(user_id)
        user_conversations[user_id] = conversation
    conversation.add_message(
        date_obj, 
        duration, 
        rec['request_object'], 
        rec['request_object2'], 
        rec['request_params'], 
        rec['request_params2'])

count = len(all_durations)
average_duration = sum(all_durations) / count
all_durations.sort()
index25 = count // 4
index50 = count // 2
index75 = (3 * count) // 4
index90 = (9 * count) // 10
index95 = (95 * count) // 100
index99 = (99 * count) // 100
index999 = (999 * count) // 1000

print ("\n%d conversations, avg. %0.3fs, 25%% < %0.3fs, 50%% < %0.3fs, " +
       "75%% < %0.3fs, 90%% < %0.3fs, 95%% < %0.3fs, 99%% < %0.3fs, 99.9%% < %0.3fs.") % (
    count,
    average_duration,
    all_durations[index25],
    all_durations[index50],
    all_durations[index75],
    all_durations[index90],
    all_durations[index95],
    all_durations[index99],
    all_durations[index999])
