from client import client

""" Recalculate residuals on invoices that need it. 
"""

c = client()

rows = c.search_fetch(
    'account.invoice',
    [
        ('state', '=', 'paid'),
        ('residual', '!=', 0)
    ],
    ['number', 'payment_ids', 'residual'])
rows = rows or []

for row in rows:
    payments = []
    payment_ids = row['payment_ids']
    if payment_ids:
        payments = c.fetch(
            'account.move.line',
            [payment_ids[0]],
            ['reconcile_id'])
    if payments:
        reconcile_id = payments[0]['reconcile_id'][0]
        reconcile = c.fetch(
            'account.move.reconcile',
            [reconcile_id],
            ['name'])[0]
        # just trigger recalculation of invoice residual.
        c.update(
            'account.move.reconcile',
            [reconcile_id],
            {'name': reconcile['name']})
    print 'Invoice %s: %s' % (row['number'], row['residual'])
print 'Success with %d invoices.' % len(rows)
